//    RW Props
// ==============
// Various Props, Gadgets & Accessories for Robowaifus : Anim Avatars edition
// -Part of the RW Foundations suite of libraries

// Filename: ./src/chibitsu/props/props.cpp
// -Definitions of the baseline RW Props library subsystem

#pragma once

#include "incls_all.hpp"

namespace rw::chibitsu::props {

//------------------------------------------------------------------------------
Flags_b::Flags_b() : Flags_b{"flags_b_obj"} {}

//------------------------------------------------------------------------------
Flags_b::Flags_b(std::string const& handle) : RW{handle} {}

//------------------------------------------------------------------------------
Flags::Flags() : Flags{"flags_obj"} {}

//------------------------------------------------------------------------------
Flags::Flags(std::string const& handle) : Flags_b{handle} {}

//------------------------------------------------------------------------------
void Flags::wave() {
  // DESIGN: redirect this into a Sumomo impl instead ?
}

///

//------------------------------------------------------------------------------
Pompoms_b::Pompoms_b() : Pompoms_b{"pompoms_b_obj"} {}

//------------------------------------------------------------------------------
Pompoms_b::Pompoms_b(std::string const& handle) : RW{handle} {}

//------------------------------------------------------------------------------
Pompoms::Pompoms() : Pompoms{"pompoms_obj"} {}

//------------------------------------------------------------------------------
Pompoms::Pompoms(std::string const& handle) : Pompoms_b{handle} {}

//------------------------------------------------------------------------------
void Pompoms::cheer() {
  // DESIGN: redirect this into a Sumomo impl instead ?
}

///

//------------------------------------------------------------------------------
Tambourine_b::Tambourine_b() : Tambourine_b{"tambourine_b_obj"} {}

//------------------------------------------------------------------------------
Tambourine_b::Tambourine_b(std::string const& handle) : RW{handle} {}

//------------------------------------------------------------------------------
Tambourine::Tambourine() : Tambourine{"tambourine_obj"} {}

//------------------------------------------------------------------------------
Tambourine::Tambourine(std::string const& handle) : Tambourine_b{handle} {}

//------------------------------------------------------------------------------
void Tambourine::shake() {
  // DESIGN: redirect this into a Sumomo impl instead ?
}

///

//------------------------------------------------------------------------------
Whistle_b::Whistle_b() : Whistle_b{"whistle_b_obj"} {}

//------------------------------------------------------------------------------
Whistle_b::Whistle_b(std::string const& handle) : RW{handle} {}

//------------------------------------------------------------------------------
Whistle::Whistle() : Whistle{"whistle_obj"} {}

//------------------------------------------------------------------------------
Whistle::Whistle(std::string const& handle) : Whistle_b{handle} {}

//------------------------------------------------------------------------------
void Whistle::tweet() {
  // DESIGN: redirect all this into a Sumomo impl instead ?
  // -eg, replace the puts() with a call to here, and move everything else there
  //
  // if (tip.tag.has("sumomo")) {
  // bones_.do_whistle_anticipation();
  // face_.scrunch_pose();
  // bones_.do_whistle();
  puts("TWWEEEEEEEEEEEET!!");
  // hearsay_.do_whistle_tweet(2s);
  // bones_.recover_from_whistle();
  // face_.bright_smile();
  // }
}

}  // namespace rw::chibitsu::props

//    --=^=--

// "______"

// rw_chibitsu_lib.v211127
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
